﻿package {
	import com.robotacid.geom.Pixel;
	import com.robotacid.util.Bresenham;
	import flash.display.Bitmap;
	import flash.display.Graphics;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	[SWF(width = "640", height = "480", frameRate="30", backgroundColor = "#CCCCCC")]
	
	/**
	 * This is a demo I've cobbled together of the Bresenham ray caster
	 * 
	 * You might ask why I'm not using Point. I just prefer using an int specific version. I have my reasons.
	 * 
	 * If you want to use Bresenham with Point, just change the following line:
	 * 
	 * public static function rayCast(p:Pixel, x1:int, y1:int, x2:int, y2:int, data:BitmapData, mask:uint = 0xFF000000):Pixel{
	 * 
	 * to
	 * 
	 * public static function rayCast(p:Point, x1:int, y1:int, x2:int, y2:int, data:BitmapData, mask:uint = 0xFF000000):Point{
	 * 
	 * 
	 * @author Aaron Steed
	 */
	public class Main extends Sprite {
		
		public var canvas:Sprite;
		public var test:Bitmap;
		public var gfx:Graphics;
		public var start_x:int = 160;
		public var start_y:int = 120;
		public var p:Pixel = new Pixel();
		[Embed(source = "assets/test.png")] public static var TestB:Class;
		
		public function Main():void {
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void {
			removeEventListener(Event.ADDED_TO_STAGE, init);
			canvas = new Sprite();
			test = new TestB();
			canvas.addChild(test);
			var shape:Shape = new Shape();
			canvas.addChild(shape);
			gfx = shape.graphics;
			canvas.scaleX = canvas.scaleY = 2;
			addChild(canvas);
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			addEventListener(MouseEvent.CLICK, onClick);
		}
		
		private function onEnterFrame(e:Event):void{
			gfx.clear();
			gfx.lineStyle(1, 0);
			gfx.moveTo(start_x, start_y);
			p = Bresenham.rayCast(p, start_x, start_y, canvas.mouseX, canvas.mouseY, test.bitmapData);
			// we draw a line with the pixel collision resolved
			gfx.lineTo(canvas.mouseX + p.x, canvas.mouseY + p.y);
			// if I simply want to test collision, then I could just check that p has returned as (0,0)
		}
		
		private function onClick(e:MouseEvent):void{
			// because Bresenham is particular about the order in which it scans a line,
			// you can't scan from inside a wall to out of a wall
			if(test.bitmapData.getPixel32(canvas.mouseX, canvas.mouseY) & 0xFF000000 != 0) return;
			start_x = canvas.mouseX;
			start_y = canvas.mouseY;
		}
	}
	
}